<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Firma\KursUebersicht\Detailsreiter\Dokumente\DokumenteUpload;

class DokumenteUploadController extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Dokumente\DokumenteUpload\DokumenteUploadController
{
  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new DokumenteUploadUseCase(
      $this->getRequestObj()
    );
  }

  protected function getNewRequestObj(): \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Dokumente\DokumenteUpload\DokumenteUploadRequest
  {
    return new DokumenteUploadRequest();
  }

  protected function getRequestObj()
  {
    $requestObj = parent::getRequestObj();
    $requestObj->belegId = \GetOperations::getVarValue('belid');

    return $requestObj;
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new DokumenteUploadFormularPresenter($pUseCaseResponse);
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    $statusMessageContainer = new \Kufer\Web\KuferTools\Utils\StatusMessages\StatusMessageContainer();
    $statusMessageContainer->addStatusMessageByOldObject($pUseCaseResponse->statusCodeAndMessage);

    return new \Kufer\Web\KuferTools\Firma\KursUebersicht\KursDetails\KursDetailsExternController(\GetOperations::getVarValue('belid'), $statusMessageContainer);
  }
}